import es
import cfglib
import gamethread
import popuplib

info = es.AddonInfo()
info.name     = 'EzSurf'
info.version  = '1.0'
info.basename = 'EzSurf'
info.url      = 'http://addons.eventscripts.com/addons/view/' + info.basename
info.author   = 'Wolf'
info.date     = 'August 18, 2009'

config = cfglib.AddonCFG(es.getAddonPath(info.basename) + '/' + info.basename + ' Config.cfg')

config.text(info.name + ' release %s options' % info.version)
config.text('./addons/eventscripts/%(basename)s/%(basename)s.cfg' % {'basename':info.basename})
config.text(info.url)
config.text('')
config.text('Load this addon with: es_load ' + info.basename)
config.text('\n')

config.text('***** EzSurf Options *****')
cvar_maxSpeed      = config.cvar('cvar_maxSpeed',       500, 'sv_maxspeed (Default = 500)')
cvar_airAccelerate = config.cvar('cvar_airAccelerate', 3000, 'sv_airaccelerate (Default = 3000)')
cvar_pushScale     = config.cvar('cvar_pushScale',     2000, 'sv_pushscale (Default = 2000)')
cvar_physPushScale = config.cvar('cvar_physPushScale', 3000, 'phys_pushscale (Default = 3000)')
cvar_unLag         = config.cvar('cvar_unLag',            1, 'sv_unlag (Default = 1)')
cvar_respawn       = config.cvar('cvar_respawn',          1, 'Turn Respawn on (1=ON / 0=OFF)')
cvar_respawnTime   = config.cvar('cvar_respawnTime',      3, 'Sets the time it takes to respawn (Default = 3)')
cvar_noblock       = config.cvar('cvar_noblock',          1, 'Turn Noblock on (1=ON / 0=OFF)')
config.text('\n')

config.write()
##############################


def load():
    enterGame = popuplib.create('enterPopup')
     
    enterGame.addline('~EzSurf Settings~')
    enterGame.addline('----------------------')
    enterGame.addline('1. sv_maxspeed '+ cvar_maxSpeed)
    enterGame.addline('2. sv_airaccelerate '+ cvar_airAccelerate)
    enterGame.addline('3. sv_pushscale '+ cvar_pushScale)
    enterGame.addline('4. sv_unlag '+ cvar_unLag)
    enterGame.addline('5. phys_pushscale '+ cvar_physPushScale)
    enterGame.addline('6. respawn time '+ cvar_respawnTime)
    enterGame.addline('----------------------')
    enterGame.addline('Created by: Wolf')
    enterGame.addline('Version: %s. Created: %s'%(info.version,info.date))
    enterGame.addline('----------------------')
    enterGame.addline('0. Close')
   
def unload():
    popuplib.delete('enterPopup')

def player_activate(ev):
    userid = ev['userid']
    gamethread.delayed(5,popuplib.send,('enterPopup', userid))
    
def es_map_start(ev):
    if 'surf_' in str(es.ServerVar('eventscripts_currentmap')).lower():
        SetSurfVariables()
        Loop()
    else:
        ResetVariables()
    
def SetSurfVariables():        
    es.ServerVar('sv_maxspeed').set(cvar_maxSpeed)
    es.msg('sv_maxspeed %s'%cvar_maxSpeed)
     
    es.ServerVar('sv_airaccelerate').set(cvar_airAccelerate)
    es.msg('sv_airaccelerate %s'%cvar_airAccelerate)
        
    es.ServerVar('sv_pushscale').set(cvar_pushScale)
    es.msg('sv_pushscale %s'%cvar_pushScale)
        
    es.ServerVar('phys_pushscale').set(cvar_physPushScale)
    es.msg('sv_pushscale %s'%cvar_physPushScale)
        
    es.ServerVar('sv_unlag').set(cvar_unLag)
    es.msg('sv_unlag %s'%cvar_unLag)
    
def ResetVariables():        
    es.ServerVar('sv_maxspeed').set(350)
    es.msg('sv_maxspeed %s'%350)
     
    es.ServerVar('sv_airaccelerate').set(10)
    es.msg('sv_airaccelerate %s'%10)
        
    es.ServerVar('sv_pushscale').set(1)
    es.msg('sv_pushscale %s'%1)
        
    es.ServerVar('phys_pushscale').set(1)
    es.msg('sv_pushscale %s'%1)
        
    es.ServerVar('sv_unlag').set(1)
    es.msg('sv_unlag %s'%1)

def round_start(ev):
    if cvar_noblock == 1:
        es.msg('#multi', '#greenEzSurf #default- #lightgreenNoblock: #greenON')
    elif cvar_noblock == 0:
        es.msg('#multi', '#greenEzSurf #default- #lightgreenNoblock: #greenOFF')
    else:
        es.msg('#multi', '#greenEzSurf #default- #lightgreenNoblock: #greenINVALID ENTRY')
        
    if cvar_respawn == 1:
        es.msg('#multi', '#greenEzSurf #default- #lightgreenRespawn: #greenON')
    elif cvar_respawn == 0:
        es.msg('#multi', '#greenEzSurf #default- #lightgreenRespawn: #greenOFF')
    else:
        es.msg('#multi', '#greenEzSurf #default- #lightgreenRespawn: #greenINVALID ENTRY')
    
def Loop():
    gamethread.delayedname(60 * 5, 'loop', Loop)
    es.msg('#multi', '#greenEzSurf #default- #lightgreenDownload: #green' + info.url)
    
def player_spawn(ev):
    userid = ev['userid']
    
    if cvar_noblock == 1:
        es.setplayerprop(userid, 'CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup', 2)
    elif cvar_noblock == 0:
        es.setplayerprop(userid, 'CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup', 5)
        
def player_death(ev):
    userid = ev['userid']
    
    es.setplayerprop(userid, 'CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup', 2)
    
    if cvar_respawn == 1 and 'surf_' in str(es.ServerVar('eventscripts_currentmap')).lower():
        gamethread.delayed(cvar_respawnTime, Respawn, userid)

def Respawn(userid):
    es.server.queuecmd('est_spawn %s'%userid)